library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity vga_pixel is
port(
  clock : in std_logic;
  red   : OUT STD_LOGIC_VECTOR(3 downto 0);
  green : OUT STD_LOGIC_VECTOR(3 downto 0);
  blue  : OUT STD_LOGIC_VECTOR(3 downto 0);
  
  g_ampel    : inout std_logic_vector (7 downto 0);
 
  vid_enable : inout std_logic;
  pixel      : inout std_logic;
  counterx   : inout unsigned (9 downto 0);
  countery   : inout unsigned (9 downto 0)
  ); 
end vga_pixel;

architecture behavioral of vga_pixel is

begin
process(clock)
begin
  if rising_edge(clock) then
    if vid_enable ='1' and pixel='1' then
      red  <="1111";
      green<="1111";
      blue <="1111";
    else
      red  <="0000";
      green<="0000";
      blue <="0000";    
    end if;
 
    if Counterx >=10 and Counterx < 40 then
      if Countery >=10 and Countery < 50 and g_ampel(7)='1' then
        red <="1111";
      elsif Countery >=10 and Countery < 50 and g_ampel(7)='0' then
        red <="0111";
        blue <="0111";
        green <="0111";
      elsif Countery >=60 and Countery < 100 and g_ampel(6)='1' then
        red <="1111";
        green <="1111";
      elsif Countery >=60 and Countery < 100 and g_ampel(6)='0' then
        red <="0111";
        blue <="0111";
        green <="0111";
      elsif Countery >=110 and Countery < 150 and g_ampel(5)='1' then
        green <="1111";
      elsif Countery >=110 and Countery < 150 and g_ampel(5)='0' then
        red <="0111";
        blue <="0111";
        green <="0111";
     end if;   
    end if;  

    if Counterx >=60 and Counterx < 90 then
      if Countery >=10 and Countery < 50 and g_ampel(4)='1' then
        red <="1111";
      elsif Countery >=10 and Countery < 50 and g_ampel(4)='0' then
        red <="0111";
        blue <="0111";
        green <="0111";
      elsif Countery >=60 and Countery < 100 and g_ampel(3)='1' then
        red <="1111";
        green <="1111";
      elsif Countery >=60 and Countery < 100 and g_ampel(3)='0' then
        red <="0111";
        blue <="0111";
        green <="0111";
      elsif Countery >=110 and Countery < 150 and g_ampel(2)='1' then
        green <="1111";
      elsif Countery >=110 and Countery < 150 and g_ampel(2)='0' then
        red <="0111";
        blue <="0111";
        green <="0111";
     end if;   
    end if;    

    if Counterx >=110 and Counterx < 140 then 
      if Countery >=60 and Countery < 100 and g_ampel(1)='1' then
        red <="1111";
      elsif Countery >=60 and Countery < 100 and g_ampel(1)='0' then
        red <="0111";
        blue <="0111";
        green <="0111";
      elsif Countery >=110 and Countery < 150 and g_ampel(0)='1' then
        green <="1111";
      elsif Countery >=110 and Countery < 150 and g_ampel(0)='0' then
        red <="0111";
        blue <="0111";
        green <="0111";
     end if;   
    end if;            
  end if;  
end process;

end behavioral;